﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace XamGridProb
{
    public static class Data
    {
        public static readonly List<String> DataList = new List<string>
            {
                "a", "b", "c", "d", "e", "f"
            };
    }


    public class zumComboBoxColumn : EditableColumn
    {

        public static readonly DependencyProperty ItemsSourceValueProperty =
            DependencyProperty.Register("ItemsSourceValue", typeof(List<String>), typeof(zumComboBoxColumn), new PropertyMetadata(null));



        public List<String> ItemsSourceValue
        {
            get { return (List<String>)GetValue(ItemsSourceValueProperty); }
            set { SetValue(ItemsSourceValueProperty, value); }
        }


        protected override ColumnContentProviderBase GenerateContentProvider()
        {
            return new zumComboBoxColumnContentProvider();
        }
    }


    public class zumComboBoxColumnContentProvider : ColumnContentProviderBase
    {
        public readonly ComboBox Editor;
        private EditableColumn _column;


         public zumComboBoxColumnContentProvider()
        {
            Editor = new ComboBox();
        }

        public override FrameworkElement ResolveDisplayElement(Cell cell, Binding cellBinding)
        {

            if (cell != null)
            {
             
                _column = cell.Column as EditableColumn;

                Editor.Width = 150;
                Editor.Height = 25;
               

                var itemsSourceBinding = new Binding
                {
                    Source = _column,
                    Path = new PropertyPath("ItemsSourceValue")
                };

                if (cellBinding != null)
                    Editor.SetBinding(Selector.SelectedItemProperty, cellBinding);

                Editor.SetBinding(ItemsControl.ItemsSourceProperty, itemsSourceBinding);
                Editor.Style = cell.EditorStyleResolved;

            }
         
            return Editor;
        }

       

        protected override FrameworkElement ResolveEditorControl(Cell cell, object editorValue, double availableWidth, double availableHeight, System.Windows.Data.Binding editorBinding)
        {
            return Editor;
        }

        public override object ResolveValueFromEditor(Cell cell)
        {
            return cell.Value;
        }
    }

}

